Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExecExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExecExpressions.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExecExpressions.cs	(revision 14513)
@@ -1,266 +1,272 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Algorithms.PushGP.Interpreter;
-using HeuristicLab.Common;
-
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    public class ExecExpandExpression : StatefullExpression
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
+  using System;
+  using System.Collections.Generic;
+  using System.Linq;
+  using System.Text;
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public class ExecExpandExpression : StatefullExpression<Expression[]> {
+    private const string PREFIX = "( ";
+    private const string POSTFIX = ")";
+    private const string DELIMITER = " ";
+
+    public readonly int Depth;
+
+    public static readonly ExecExpandExpression Empty = new ExecExpandExpression(new Expression[0]);
+
+    public bool IsEmpty { get; private set; }
+
+    private int[] treeIndex;
+
+    public ExecExpandExpression(Expression[] state)
+      : base(state) {
+      this.IsEmpty = this.State.Length == 0;
+      this.InitId();
+
+      var subExpressions = state.Where(e => e.GetType() == typeof(ExecExpandExpression));
+
+      this.Depth = subExpressions.Any() ? subExpressions.Select(e => e as ExecExpandExpression).Max(e => e.Depth) : 1;
+    }
+
+    //private void CheckIfNested(int level, Expression parent)
+    //{
+    //    for (var i = 0; i < State.Length; i++)
+    //    {
+    //        if (State[i].GetType() == typeof(ExecExpandExpression))
+    //        {
+    //            if (parent == State[i])
+    //            {
+    //                Debugger.Break();
+    //            }
+
+    //            (State[i] as ExecExpandExpression).CheckIfNested(level + 1, parent);
+    //        }
+    //    }
+    //}
+
+    public ExecExpandExpression(ExecExpandExpression origin) : base(new Expression[origin.State.Length]) {
+      Array.Copy(origin.State, this.State, origin.State.Length);
+
+      this.IsEmpty = origin.IsEmpty;
+    }
+
+    public IReadOnlyList<Expression> Expressions { get { return this.State; } }
+
+    /// <summary>
+    /// Returns the amount of elements in the whole tree
+    /// </summary>
+    /// <returns></returns>
+    public int TotalCount
     {
-        private const string prefix = "( ";
-        private const string postfix = ")";
-        private const string delimiter = " ";
-
-        public readonly Expression[] Expressions;
-        public readonly bool IsEmpty;
-
-        private List<Expression> treeIndex;
-
-        public static readonly Expression Empty = new ExecExpandExpression(new Expression[0]);
-
-        public ExecExpandExpression(Expression[] expressions)
-        {
-            Expressions = expressions;
-            IsEmpty = expressions.Length == 0;
+      get
+      {
+        if (this.IsEmpty) {
+          return 1;
         }
 
-        // copy constructor
-        public ExecExpandExpression(ExecExpandExpression original, Cloner cloner) : base(original, cloner)
-        {
-            Expressions = new Expression[original.Expressions.Length];
-            Array.Copy(original.Expressions, Expressions, original.Expressions.Length);
-
-            if (original.treeIndex != null)
-            {
-                treeIndex = original.treeIndex.Select(e => cloner.Clone(e)).ToList();
-            }
-
-            IsEmpty = original.IsEmpty;
+        this.BuildIndexIfNecessary();
+
+        // + 1 because this is also counted
+        return this.treeIndex[0] + 1;
+      }
+    }
+
+    protected override string InitStringRepresentation() {
+      var sb = new StringBuilder();
+
+      sb.Append(PREFIX);
+#if DEBUG
+      for (var i = this.State.Length - 1; i >= 0; i--)
+        sb.Append(this.State[i] + DELIMITER);
+#else
+      sb.Append(this.TotalCount.ToString() + DELIMITER);
+#endif
+
+      sb.Append(POSTFIX);
+
+      return sb.ToString();
+    }
+
+    protected sealed override int InitId() {
+      var hash = 19 * 31 + this.GetType().GetHashCode();
+
+      for (var i = this.State.Length - 1; i >= 0; i--) hash = hash * 31 + this.State[i].GetHashCode();
+
+      return hash;
+    }
+
+    public ExecExpandExpression Copy() {
+      // as the empty list is a static stateless expression, no copy required
+      return this == Empty || this.IsEmpty
+        ? Empty
+        : new ExecExpandExpression(this.State);
+    }
+
+    public Expression[] CopyExpressions() {
+      var copy = new Expression[this.State.Length];
+      Array.Copy(this.State, copy, this.State.Length);
+
+      return copy;
+    }
+
+    public override int GetHashCode() {
+      return base.GetHashCode();
+    }
+
+    public override string ToString() {
+      return this.StringRepresentation;
+    }
+
+    public override bool Equals(object obj) {
+      if ((obj == null) || (obj.GetType() != typeof(ExecExpandExpression))) return false;
+
+      return this.GetHashCode() == obj.GetHashCode();
+    }
+
+    public override void Eval(IPushGpInterpreter interpreter) {
+      interpreter.ExecStack.Push(this.State);
+    }
+
+    /// <summary>
+    ///     Returns the element with the given index whereby the tree is indexed in depth first manner
+    /// </summary>
+    /// <param name="index">The index of the required element</param>
+    /// <returns>The required element</returns>
+    public Expression GetFromTree(int index) {
+      return this.GetFromTree(index, (root, parent, child, childIndex, parentIndex) => child);
+    }
+
+    /// <returns>The required element</returns>
+    public T GetFromTree<T>(int index, Func<ExecExpandExpression, ExecExpandExpression, Expression, int, int, T> resolver) {
+      return this.GetFromTree(index, 0, null, resolver);
+    }
+
+    private T GetFromTree<T>(int index, int parentIndex, ExecExpandExpression parent, Func<ExecExpandExpression, ExecExpandExpression, Expression, int, int, T> resolver) {
+      if (index == 0) return resolver(parent, parent, this, 0, parentIndex);
+
+      this.BuildIndexIfNecessary();
+
+      var min = this.State.Length - 1;
+      var max = 0;
+      var mid = (min + max) / 2;
+
+      while ((max <= min) && (this.treeIndex[mid] != index)) {
+        if (this.treeIndex[mid] > index) max = mid + 1;
+        else min = mid - 1;
+
+        mid = (min + max) / 2;
+      }
+
+      return this.treeIndex[mid] == index
+        ? resolver(parent, this, this.State[mid], mid, parentIndex)
+        : (this.State[mid + 1] as ExecExpandExpression).GetFromTree(index - this.treeIndex[mid + 1], mid + 1, this, resolver);
+    }
+
+    private void BuildIndexIfNecessary() {
+      if (this.treeIndex != null) return;
+
+      this.BuildIndex();
+    }
+
+    private void BuildIndex() {
+      this.treeIndex = new int[this.State.Length];
+
+      var next = 1;
+
+      for (var i = this.State.Length - 1; i >= 0; i--) {
+        var subExpression = this.State[i];
+
+        this.treeIndex[i] = next;
+
+        if (subExpression.GetType() == typeof(ExecExpandExpression)) {
+          next += (subExpression as ExecExpandExpression).TotalCount;
+        } else {
+          next++;
         }
-
-        /// <summary>
-        /// Use this method to ensure the amount of expressions is not higher than the limit configured (Configuration.MaxPointsInProgram)
-        /// </summary>
-        /// <param name="expressions"></param>
-        /// <param name="config"></param>
-        /// <returns>Returns an ExpandExpression if maxPoints smaller or equal to Configuration.MaxProgramPoints and Noop otherwise</returns>
-        public static Expression TryCreate(Expression[] expressions, Configuration config)
-        {
-            if (config.MaxPointsInProgram > expressions.Length)
-            {
-                return new ExecExpandExpression(expressions);
-            }
-            else
-            {
-                return new CodeNoopExpression();
-            }
-        }
-
-        protected override string InitStringRepresentation()
-        {
-            var sb = new StringBuilder();
-
-            sb.Append(prefix);
-
-            for (var i = Expressions.Length - 1; i >= 0; i--)
-            {
-                sb.Append(Expressions[i].ToString() + delimiter);
-            }
-
-            sb.Append(postfix);
-
-            return sb.ToString();
-        }
-
-        protected override int InitId()
-        {
-            unchecked
-            {
-                var hash = 19;
-                foreach (var e in Expressions)
-                {
-                    hash *= 31 + e.GetHashCode();
-                }
-
-                return hash;
-            }
-        }
-
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            return new ExecExpandExpression(this, cloner);
-        }
-
-        public override int GetHashCode()
-        {
-            return base.GetHashCode();
-        }
-
-        public override bool Equals(object obj)
-        {
-            if (obj == null || obj.GetType() != typeof(ExecExpandExpression))
-            {
-                return false;
-            }
-
-            if (ReferenceEquals(this, obj))
-            {
-                return true;
-            }
-
-            var other = obj as ExecExpandExpression;
-
-            return Expressions.SequenceEqual(other.Expressions);
-        }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            interpreter.ExecStack.Push(Expressions);
-        }
-
-        /// <summary>
-        /// Returns the amount of elements in the whole tree
-        /// </summary>
-        /// <returns></returns>
-        public int TotalCount
-        {
-            get
-            {
-                BuildIndexIfNecessary();
-
-                return treeIndex.Count;
-            }
-        }
-
-        /// <summary>
-        /// Returns the element with the given index whereby the tree is indexed in depth first manner
-        /// </summary>
-        /// <param name="index">The index of the required element</param>
-        /// <returns>The required element</returns>
-        public Expression GetFromTree(int index)
-        {
-            BuildIndexIfNecessary();
-
-            return treeIndex[index];
-        }
-
-        private void BuildIndexIfNecessary()
-        {
-            if (treeIndex != null)
-                return;
-
-            treeIndex = new List<Expression>(Expressions.Length) { this };
-
-            for (var i = Expressions.Length - 1; i >= 0; i--)
-            {
-                var subExpression = Expressions[i];
-
-                if (subExpression.GetType() == typeof(ExecExpandExpression))
-                {
-                    var expand = subExpression as ExecExpandExpression;
-
-                    expand.BuildIndexIfNecessary();
-                    treeIndex.AddRange(expand.treeIndex);
-                }
-                else
-                {
-                    treeIndex.Add(subExpression);
-                }
-
-            }
-        }
-    }
-
-    /// <summary>
-    /// If the top item of the BOOLEAN stack is TRUE then this removes the second item on the EXEC stack, leaving the first item to be
-    /// executed. If it is false then it removes the first item, leaving the second to be executed. This is similar to CODE.IF except
-    /// that it operates on the EXEC stack. This acts as a NOOP unless there are at least two items on the EXEC stack and one item on
-    /// the BOOLEAN stack.
-    /// </summary>
-    public class ExecIfExpression : StatelessExpression
-    {
-        protected override string InitStringRepresentation() { return "EXEC.IF"; }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            // not enough arguments on stack
-            if (interpreter.BooleanStack.Count == 0 ||
-                interpreter.ExecStack.Count < 2)
-                return;
-
-            var condition = interpreter.BooleanStack.Pop();
-
-            if (condition)
-                interpreter.ExecStack.RemoveAt(interpreter.ExecStack.Count - 2);
-            else
-                interpreter.ExecStack.RemoveTop();
-        }
-    }
-
-    /// <summary>
-    /// The Push implementation of the "Y combinator". Inserts beneath the top item of the EXEC stack a new item of the form
-    /// "( EXEC.Y <TopItem> )".
-    /// </summary>
-    public class ExecYExpression : StatelessExpression
-    {
-        protected override string InitStringRepresentation() { return "EXEC.Y"; }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            // not enough arguments on stack
-            if (interpreter.ExecStack.Count == 0)
-                return;
-
-            var expandExpression = ExecExpandExpression.TryCreate(new[]
-            {
-                interpreter.ExecStack.Top,
-                new ExecYExpression()
-            }, interpreter.Configuration);
-
-            interpreter.ExecStack.Insert(interpreter.ExecStack.Count - 1, expandExpression);
-        }
-    }
-
-    /// <summary>
-    /// The Push implementation of the "K combinator". Removes the second item on the EXEC stack.
-    /// </summary>
-    public class ExecKExpression : StatelessExpression
-    {
-        protected override string InitStringRepresentation() { return "EXEC.K"; }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            if (interpreter.ExecStack.Count < 2)
-                return;
-
-            var top = interpreter.ExecStack.Pop();
-            interpreter.ExecStack.SetTop(top);
-        }
-    }
-
-    /// <summary>
-    /// The Push implementation of the "S combinator". Pops 3 items from the EXEC stack, which we will call A, B, and C
-    /// (with A being the first one popped). Then pushes a list containing B and C back onto the EXEC stack, followed by
-    /// another instance of C, followed by another instance of A.
-    /// </summary>
-    public class ExecSExpression : StatelessExpression
-    {
-        protected override string InitStringRepresentation() { return "EXEC.S"; }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            if (interpreter.ExecStack.Count < 3)
-                return;
-
-            var expressions = interpreter.ExecStack.Pop(2);
-            var a = expressions[1];
-            var b = expressions[0];
-            var c = interpreter.ExecStack.Top;
-
-            interpreter.ExecStack.SetTop(ExecExpandExpression.TryCreate(new[] { c, b }, interpreter.Configuration));
-            interpreter.ExecStack.Push(c, a);
-        }
-    }
+      }
+    }
+  }
+
+  /// <summary>
+  /// If the top item of the BOOLEAN stack is TRUE then this removes the second item on the EXEC stack, leaving the first
+  /// item to be executed. If it is false then it removes the first item, leaving the second to be executed. This is similar to
+  /// CODE.IF except that it operates on the EXEC stack. This acts as a NOOP unless there are at least two items on the EXEC stack and
+  /// one item on the BOOLEAN stack.
+  /// </summary>
+  public class ExecIfExpression : StatelessExpression {
+    protected override string InitStringRepresentation() {
+      return "EXEC.IF";
+    }
+
+    public override void Eval(IPushGpInterpreter interpreter) {
+      // not enough arguments on stack
+      if ((interpreter.BooleanStack.Count == 0) || (interpreter.ExecStack.Count < 2)) return;
+
+      var condition = interpreter.BooleanStack.Pop();
+
+      if (condition) interpreter.ExecStack.RemoveAt(interpreter.ExecStack.Count - 2);
+      else interpreter.ExecStack.RemoveTop();
+    }
+  }
+
+  /// <summary>
+  ///     Inserts beneath the top item of the EXEC stack a new item of the form
+  ///     "( EXEC.Y <TopItem> )".
+  /// </summary>
+  public class ExecYExpression : StatelessExpression {
+    protected override string InitStringRepresentation() {
+      return "EXEC.Y";
+    }
+
+    public override void Eval(IPushGpInterpreter interpreter) {
+      // not enough arguments on stack
+      if ((interpreter.ExecStack.Count == 0) || (interpreter.Configuration.MaxPointsInProgram < 2)) return;
+
+      var top = interpreter.ExecStack.Top;
+      var result = new ExecExpandExpression(new[] { top, new ExecYExpression() });
+
+      interpreter.ExecStack.Insert(interpreter.ExecStack.Count - 1, result);
+    }
+  }
+
+  /// <summary>
+  ///     Removes the second item on the EXEC stack.
+  /// </summary>
+  public class ExecKExpression : StatelessExpression {
+    protected override string InitStringRepresentation() {
+      return "EXEC.K";
+    }
+
+    public override void Eval(IPushGpInterpreter interpreter) {
+      if (interpreter.ExecStack.Count < 2) return;
+
+      var top = interpreter.ExecStack.Pop();
+      interpreter.ExecStack.SetTop(top);
+    }
+  }
+
+  /// <summary>
+  ///     Pops 3 items from the EXEC stack, which we will call A, B, and C
+  ///     (with A being the first one popped). Then pushes a list containing B and C back onto the EXEC stack, followed by
+  ///     another instance of C, followed by another instance of A.
+  /// </summary>
+  public class ExecSExpression : StatelessExpression {
+    protected override string InitStringRepresentation() {
+      return "EXEC.S";
+    }
+
+    public override void Eval(IPushGpInterpreter interpreter) {
+      if (interpreter.ExecStack.Count < 3) return;
+
+      var State = interpreter.ExecStack.Pop(2);
+      var a = State[1];
+      var b = State[0];
+      var c = interpreter.ExecStack.Top;
+
+      var newTop = new ExecExpandExpression(new[] { c, b });
+
+      interpreter.ExecStack.SetTop(newTop);
+      interpreter.ExecStack.Push(c, a);
+    }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Expression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Expression.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Expression.cs	(revision 14513)
@@ -1,70 +1,39 @@
-﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
-using HeuristicLab.Common;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    public abstract class Expression : DeepCloneable
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public abstract class Expression {
+    protected int id;
+    protected string stringRepresentation;
+
+    public string StringRepresentation
     {
-        private string stringRepresentation;
-        private int id;
+      get { return this.stringRepresentation ?? (this.stringRepresentation = this.InitStringRepresentation()); }
+    }
 
-        public Expression()
-        { }
+    public int Id
+    {
+      get
+      {
+        if (this.id == default(int))
+          this.id = this.InitId();
 
-        /// <summary>
-        /// Clone Constructor
-        /// </summary>
-        protected Expression(Expression origin, Cloner cloner)
-        {
-            stringRepresentation = origin.stringRepresentation;
-            id = origin.id;
-        }
+        return this.id;
+      }
+    }
 
-        public abstract void Eval(IInterpreter interpreter);
+    public abstract void Eval(IPushGpInterpreter interpreter);
 
-        protected abstract int InitId();
+    protected abstract int InitId();
 
-        protected abstract string InitStringRepresentation();
+    protected abstract string InitStringRepresentation();
 
-        public string StringRepresentation
-        {
-            get
-            {
-                if (stringRepresentation == null)
-                {
-                    stringRepresentation = InitStringRepresentation();
-                }
+    public override bool Equals(object obj) {
+      return (obj != null) && ((this.GetHashCode() == obj.GetHashCode()) || (this.GetType() == obj.GetType()));
+    }
 
-                return stringRepresentation;
-            }
-        }
-
-        public int Id
-        {
-            get
-            {
-                if (id == default(int))
-                {
-                    id = InitId();
-                }
-
-                return id;
-            }
-        }
-
-        public override bool Equals(object obj)
-        {
-            return obj != null && (GetHashCode() == obj.GetHashCode() || GetType() == obj.GetType());
-        }
-
-        public override string ToString()
-        {
-            return StringRepresentation;
-        }
-
-        public override int GetHashCode()
-        {
-            return Id;
-        }
+    public override int GetHashCode() {
+      return this.Id;
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExpressionTable.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExpressionTable.cs	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExpressionTable.cs	(revision 14513)
@@ -0,0 +1,143 @@
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
+  using System;
+  using System.Collections.Generic;
+  using System.Linq;
+
+  public static class ExpressionTable {
+    private static readonly Dictionary<string, Expression> statelessExpressionTable;
+
+    private static readonly Dictionary<string, Func<Expression>> statefullExpressionFactory;
+
+    public static int Count;
+
+    static ExpressionTable() {
+      statelessExpressionTable = GetStatelessExperssionTable(e => e.StringRepresentation);
+      statefullExpressionFactory = GetStatefullExpressionFactory(e => e.StringRepresentation);
+
+      Count = statelessExpressionTable.Count + statefullExpressionFactory.Count;
+    }
+
+    public static int StatelessCount
+    {
+      get
+      {
+        return statelessExpressionTable.Count;
+      }
+    }
+
+    public static int StatefullCount
+    {
+      get
+      {
+        return statefullExpressionFactory.Count;
+      }
+    }
+
+    private static Dictionary<string, Expression> GetStatelessExperssionTable(Func<Expression, string> keyFunc) {
+      var dictionary = new Dictionary<string, Expression>();
+      var expressionTypes = GetExpressionTypes(typeof(StatelessExpression));
+
+      foreach (var type in expressionTypes) {
+        var expression = Activator.CreateInstance(type) as Expression;
+        var key = keyFunc(expression);
+
+        dictionary.Add(key, expression);
+      }
+
+      return dictionary;
+    }
+
+    private static Dictionary<string, Func<Expression>> GetStatefullExpressionFactory(Func<Expression, string> keyFunc) {
+      var dictionary = new Dictionary<string, Func<Expression>>();
+      var statefullExpressionType = typeof(StatefullExpression<>);
+      var expressionTypes = GetExpressionTypes(statefullExpressionType);
+
+      foreach (var type in expressionTypes) {
+        // Make a NewExpression that calls the ctor
+        var newExp = System.Linq.Expressions.Expression.New(type);
+
+        // Create a lambda with the New expression as body
+        var creator = System.Linq.Expressions.Expression.Lambda<Func<Expression>>(newExp).Compile();
+        var expression = creator();
+        var key = keyFunc(expression);
+
+        dictionary.Add(key, creator);
+      }
+
+      return dictionary;
+    }
+
+    private static bool IsSubclassOf(Type type, Type baseType) {
+      if (type == null || baseType == null || type == baseType)
+        return false;
+
+      if (baseType.IsGenericType == false) {
+        if (type.IsGenericType == false)
+          return type.IsSubclassOf(baseType);
+      } else {
+        baseType = baseType.GetGenericTypeDefinition();
+      }
+
+      type = type.BaseType;
+      var objectType = typeof(object);
+      while (type != objectType && type != null) {
+        var curentType = type.IsGenericType ? type.GetGenericTypeDefinition() : type;
+        if (curentType == baseType)
+          return true;
+
+        type = type.BaseType;
+      }
+
+      return false;
+    }
+
+    private static IEnumerable<Type> GetExpressionTypes(Type baseType) {
+      return from domainAssembly in AppDomain.CurrentDomain.GetAssemblies()
+             from assemblyType in domainAssembly.GetTypes()
+             where !assemblyType.IsAbstract &&
+                   IsSubclassOf(assemblyType, baseType) &&
+                   assemblyType.GetConstructor(Type.EmptyTypes) != null
+             select assemblyType;
+    }
+
+    public static Expression GetExpression(int index) {
+      // TODO: build lookup table for index to determine the key for the dictionary (get rid of ElementAt, is it slow?)
+      return index < StatelessCount
+               ? statelessExpressionTable.ElementAt(index).Value
+               : statefullExpressionFactory.ElementAt(index - StatelessCount).Value();
+    }
+
+    public static Expression GetExpression(string symbol) {
+      Expression expression;
+      if (TryGetStatelessExpression(symbol, out expression) || TryGetStatefullExpression(symbol, out expression)) return expression;
+
+      return null;
+    }
+
+    public static Expression GetStatelessExpression(string symbol) {
+      Expression expression;
+      if (statelessExpressionTable.TryGetValue(symbol, out expression)) return expression;
+      throw new NotSupportedException("Expression not supported: " + symbol);
+    }
+
+    public static bool TryGetStatelessExpression(string name, out Expression expression) {
+      return statelessExpressionTable.TryGetValue(name, out expression);
+    }
+
+    public static Expression GetStatefullExpression(string symbol) {
+      Func<Expression> creator;
+      if (statefullExpressionFactory.TryGetValue(symbol, out creator)) return creator();
+      throw new NotSupportedException("Expression not supported: " + symbol);
+    }
+
+    public static bool TryGetStatefullExpression(string name, out Expression expression) {
+      Func<Expression> creator;
+      if (statefullExpressionFactory.TryGetValue(name, out creator)) {
+        expression = creator();
+        return true;
+      }
+      expression = default(Expression);
+      return false;
+    }
+  }
+}
